
#include <ctype.h>

#define OvfChk(s,n)		{if ( ((s)+n) >= &(LexText[LEX_BUF-3]) ) {				\
							fprintf(stderr, "LexText:\n%s", LexText);			\
							fatalFL( eMsg("lexical buffer OVF size %d",LEX_BUF),\
								FileStr[CurFile], lex_line);}}

#define AddChar(s,c)	addc(&(s), (c))
#define AddStr(s,b,n)	adds(&(s), (b), (n))

static
next()
{
	if ( cur_char == '\n' || cur_char == '\r' ) lex_line++;
	nextChar();
}

static
addc(s,c)
char **s;
char c;
{
	OvfChk(*s,1);
	**s = c;
	(*s)++;
}

static
adds(s,b,n)
char **s, *b;
int n;
{
	OvfChk(*s,n);
	strcpy(*s, b);
	(*s) += n;
}

/* Scarf everything in [...] */
static
scarfParm()
{
	char *s;
	int level = 1;
	
	s = LexText;
	while ( cur_char != LEX_EOF )
	{
		if ( cur_char == '"' )	/* scarf "..." ignoring \" */
		{
			AddChar(s,'"');
			next();
			while ( cur_char != '"' )
			{
				if ( cur_char == '\\' )
				{
					AddChar(s,cur_char);
					next();
					if ( cur_char == '\n' ) lex_line++;
				}
				AddChar(s,cur_char);
				next();
			}
			AddChar(s,'"');
			next();
		}
		switch ( cur_char )
		{
			case '$'	:	/* expression can have $var */
				next();
				if ( cur_char == '$' )
				{
					AddStr(s, "aRet", 4);
					next();
					break;
				}
				if ( isalpha(cur_char) )
				{
					while ( isalpha(cur_char) )
					{
						next();
					}
					AddStr(s, "aRet", 4);
					break;
				}
				if ( !isdigit(cur_char) )
				{
					AddChar(s,'$');
					AddChar(s,cur_char);
					next();
					break;
				}
				sprintf(s, "aArg(");
				s += 5;
				while ( isdigit(cur_char) )
				{
					AddChar(s,cur_char);
					next();
				}
				AddChar(s,')');
				break;
			case '['	: 				/* Nest a level of [ */
				AddChar(s,cur_char);
				next();
				level++;
				break;
			case ']'	:
				--level;				/* Back down a level */
				if ( level == 0 )		/* Back to level 0? */
				{
					next();
					*s = '\0';
					return;
				}
				AddChar(s,cur_char);
				next();
				break;
			case '\\'	:
				next();
				switch ( cur_char )
				{
					case '>'    :   AddChar(s,'>'); break;
					case '$'    :   AddChar(s,'$'); break;
					default     :   AddChar(s,'\\'); AddChar(s,cur_char); break;
				}
				next();
				break;
			default		:
				AddChar(s,cur_char);
				next();
		}
	}
	*s = '\0';
}

static
scarfComment()
{
	while ( cur_char != LEX_EOF )
	{
		if ( cur_char == '*' )
		{
			next();
			if ( cur_char == '/' )
			{
				next();
				return;
			}
		}
		next();
	}
}

scarfAction()
{
	char *s;

	s = LexText;
	while ( cur_char != LEX_EOF )
	{
		if ( cur_char == '"' )	/* scarf "..." ignoring \" */
		{
			AddChar(s,'"');
			next();
			while ( cur_char != '"' )
			{
				if ( cur_char == '\\' )
				{
					AddChar(s,cur_char);
					next();
				}
				AddChar(s,cur_char);
				next();
			}
			AddChar(s,'"');
			next();
		}
		if ( cur_char == '$' )
		{
			next();
			if ( cur_char == '$' )
			{
				AddStr(s, "aRet", 4);
				next();
				continue;
			}
			if ( isalpha(cur_char) )
			{
				while ( isalpha(cur_char) )
				{
					next();
				}
				AddStr(s,"aRet",4);
				continue;
			}
			if ( !isdigit(cur_char) )
			{
				AddChar(s,'$');
				AddChar(s,cur_char);
				next();
				continue;
			}
			AddStr(s, "aArg(", 5);
			while ( isdigit(cur_char) )
			{
				AddChar(s,cur_char);
				next();
			}
			AddChar(s,')');
			continue;
		}
		if ( cur_char == '\\' )
		{
			next();
			switch ( cur_char )
			{
				case '>'    :	AddChar(s,cur_char); break;
				case '$'    :	AddChar(s,cur_char); break;
				default     :	AddChar(s,'\\'); AddChar(s,cur_char); break;
			}
			next();
		}
		else
		if ( cur_char == '>' )
		{
			next();
			if ( cur_char == '>' )
			{
				*s = '\0';
				next();
				return;
			}
			AddChar(s,'>');
			AddChar(s,cur_char);
			next();
		}
		else
		{
			AddChar(s,cur_char);
			next();
		}
	}
}

static
scarfQuotedTerm()
{
	char *s;

	s = LexText+2;
	if ( cur_char == '"' && LexText[1] == '\\' )
	{
		LexText[1] = '"';
		next();
	}
	while ( cur_char != LEX_EOF )
	{
		if ( cur_char == '\\' )
		{
			next();
			switch ( cur_char )
			{
				case '"'	:   AddChar(s,cur_char); break;
				default		:   AddChar(s,'\\'); AddChar(s,cur_char); break;
			}
			next();
		}
		else if ( cur_char == '"' )
		{
			next();
			AddChar(s,'"');
			*s = '\0';
			return;
		}
		else
		{
			AddChar(s,cur_char);
			next();
		}
	}
}
